# A program which manages Ubuntu-it's web test server
# Copyright (C) 2015  Pietro Albini <pietroalbini@ubuntu.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; witout even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os


def is_root_valid(path):
    """Check if a root directory is valid"""
    # Eh...
    if not os.path.exists(path):
        return False

    required_dirs = ["git", "envs", "caches", "public", "socks",
                     "socks/branches"]
    required_files = ["config.json", "details.json"]
    base = os.path.abspath(path)

    for dir in required_dirs:
        dir_path = os.path.join(base, dir)
        if not (os.path.exists(dir_path) and os.path.isdir(dir_path)):
            return False
    for file in required_files:
        file_path = os.path.join(base, file)
        if not (os.path.exists(file_path) and os.path.isfile(file_path)):
            return False

    return True
